!
! Module: lccorr_test_mod

module lccorr_test_mod

  use dal
  use param  
!  use errorHandling

  use lccorr_include
  use test_mod

  implicit none 

  private 

  public lccorr_test

contains 

  !---------------------------------------------------------------------
  subroutine lccorr_test
  !---------------------------------------------------------------------

    implicit none 

    real(single), allocatable :: ratePerCcd(:)

    !-------------------------------------------------------------------
    ! Start:

    call readParameters

!call test_makeTs(eventSetName, tsName='dummy_src_ts.ds', baseRate=6.0&
!, sineAmp=1.0, sinePeriod=100.0, numBins=100, binWidth=20.0d0&
!, centreTime1stBin=0.0d0)

!call test_makeTs(eventSetName, tsName='dummy_bkg_ts.ds', baseRate=1.0&
!, sineAmp=0.0, sinePeriod=100.0, numBins=100, binWidth=10.0d0&
!, centreTime1stBin=55.0d0)

allocate(ratePerCcd(4))
ratePerCcd = 0.0
ratePerCcd(1) = 100.0
ratePerCcd(2) = 20.0
ratePerCcd(3) = 15.0
ratePerCcd(4) = 65.0

!allocate(ratePerCcd(1))
!ratePerCcd(1) = 15.0

!call test_makeEvlist(evlistName='evlist_Rand_Dith.ds', randomize=.true.&
!, steadyEvents=.false., cosmicFraction=0.85, deadTimeFraction=0.92&
!, tStart=1.0d8, duration=10000.0, ratePerCcd=ratePerCcd)

!call test_addGtiTable('gtis_RD.ds', 1, 1.0d8, 1.0001d8, 5)
!call test_addGtiTable('gtis_RD.ds', 2, 1.0d8, 1.0001d8, 5)
!call test_addGtiTable('gtis_RD.ds', 3, 1.0d8, 1.0001d8, 5)
!call test_addGtiTable('gtis_RD.ds', 4, 1.0d8, 1.0001d8, 5)

!return

call test_correctTimeDep(ratePerCcd, treatGti, treatCosmicRays, treatDeadTime, eventSetName, outSetName)
!print *, 'ccc'
return

  end subroutine lccorr_test

  !---------------------------------------------------------------------
  subroutine readParameters
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start:

    call message(AppMsg, Verbose, 'Getting command-line parameters.')

    srcTsSetName = stringParameter('srctsset')
    eventSetName = stringParameter('eventset')

    withBkgTsSet = booleanParameter('withbkgtsset')
    bkgTsSetName = stringParameter('bkgtsset')

    withSrcSpecSet = booleanParameter('withsrcspecset')
    srcSpecSetName = stringParameter('srcspecset')

    withBkgSpecSet = booleanParameter('withbkgspecset')
    bkgSpecSetName = stringParameter('bkgspecset')

    rebinSpec = booleanParameter('rebinspec')
    rebinSpecMode = stringParameter('rebinspecmode')
    numRBspecRows = intParameter('nspecbins')
    specBinDiv = realParameter('specbindiv')

!    withSrcImgSet = booleanParameter('withsrcimgset')
withSrcImgSet = .false.
!    srcImgSetName = stringParameter('srcimgset')
    srcImgModel = stringParameter('srcimgmodel')
    withPointSrcPosn = booleanParameter('withpointsrcposn')
    pointSrcRA = realParameter('pointsrcra')
    pointSrcDec = realParameter('pointsrcdec')

!    withBkgImgSet = booleanParameter('withbkgimgset')
withBkgImgSet = .false.
!    bkgImgSetName = stringParameter('bkgimgset')
    bkgImgModel = 'uniform'

    outSetName = stringParameter('outset')

    treatVignet = booleanParameter('treatvignet')
!    treatBorderEvents = booleanParameter('treatborderevents')
!    treatSelPatterns = booleanParameter('treatselpatterns')
treatSelPatterns = .true.
    treatFilterTrans = booleanParameter('treatfiltertrans')
    treatQuantumEff = booleanParameter('treatquantumeff')
    treatCosmicRays = booleanParameter('treatcosmicrays')
    treatDeadTime = booleanParameter('treatdeadtime')
    treatGti = booleanParameter('treatgti')
    treatOotes = booleanParameter('treatootes')  

    applyCorrections = booleanParameter('applycorrections')
    subtractBkg = booleanParameter('subtractbkg')

! NOTE!!! Rebinning of time-dependent factors is currently not done. With
! the present algorithms for calculating fracexp, little or no time would
! be saved by rebinning.
!    nTimeBins = 0
!    timeBinDiv = 1.0
!    rebinTime = booleanParameter('rebintime')
!    if (rebinTime) then
!      rebinTimeMode = stringParameter('rebintimemode')
!      if (trim(rebinTimeMode) .eq. 'tonumber') then
!        nTimeBins = intParameter('ntimebins')
!      else
!        timeBinDiv = realParameter('timebindiv')
!      end if
!    end if

  end subroutine readParameters

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none 

    !-------------------------------------------------------------------
    ! Start:

  end subroutine template

end module lccorr_test_mod
